﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Runtime.InteropServices;

namespace tm_AI
{
    public partial class Form1 : Form
    {
        IntPtr hPort;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Get number of COM port and  assign COM port name to list in cmbComPort.
            foreach (string s in SerialPort.GetPortNames())
            {
                cmbComPort.Items.Add(s);
            }
            cmbComPort.SelectedIndex = 0;
            cmdModules.SelectedIndex = 0;
            btnOpenCOM.Enabled = true;
            btnCloseCOM.Enabled = false;            
        }

        private void btnOpenCOM_Click(object sender, EventArgs e)
        {
            //Open com port
            hPort = PACNET.UART.Open(cmbComPort.Text + "," + txtBaurdRate.Text);

            if (hPort == (IntPtr)(-1))
            {
                MessageBox.Show("error code:0x" + PACNET.ErrHandling.GetLastError().ToString("X") + "," + PACNET.ErrHandling.GetErrorMessage(PACNET.ErrHandling.GetLastError()));
            }
            else
            {
                btnOpenCOM.Enabled = false;
                btnCloseCOM.Enabled = true;
            }
        }

        private void btnCloseCOM_Click(object sender, EventArgs e)
        {
            //Close com port
            PACNET.UART.Close(hPort);
            btnOpenCOM.Enabled = true;
            btnCloseCOM.Enabled = false;
        }

        private void cmdModules_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (cmdModules.Text)
            {
                case "tM-AD2" :
                case "tM-AD4P2C2":
                    txtChannel.Text = "2";
                    break;                
                case "tM-AD5" :
                case "tM-AD5C":
                    txtChannel.Text = "5";
                    break;
                case "tM-AD8" :
                case "tM-AD8C":
                case "tM-TH8" :
                    txtChannel.Text = "8";
                    break;
            }
        }

        private void btnReadAI_Click(object sender, EventArgs e)
        {
            float fValue = 0;
            bool iRet;
            int iReadChannel = int.Parse(txtReadChannel.Text);
            int iChannel = int.Parse(txtChannel.Text);

            if (iReadChannel <= iChannel)
            {
                //Read data
                iRet = PACNET.PAC_IO.ReadAI(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), iReadChannel, iChannel, ref fValue);
                if (iRet == false)
                {
                    MessageBox.Show("error code:0x" + PACNET.ErrHandling.GetLastError().ToString("X") + "," + PACNET.ErrHandling.GetErrorMessage(PACNET.ErrHandling.GetLastError()));
                }
                else
                {
                    txtAIValue.Text = fValue.ToString();
                }
            }
            else
            {
                MessageBox.Show("Your read channel is error , please rewrite read channel");
            }
        }
    }
}
