﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Runtime.InteropServices;

namespace tm_AO
{
    public partial class Form1 : Form
    {
        IntPtr hPort;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Get number of COM port and  assign COM port name to list in cmbComPort.
            foreach (string s in SerialPort.GetPortNames())
            {
                cmbComPort.Items.Add(s);
            }
            cmbComPort.SelectedIndex = 0;
            cmdModules.SelectedIndex = 0;
            btnOpenCOM.Enabled = true;
            btnCloseCOM.Enabled = false;
            btnWriteAO.Enabled = true;
            btnWrite.Enabled = false;
      }

        private void btnOpenCOM_Click(object sender, EventArgs e)
        {
            //Open com port
            hPort = PACNET.UART.Open(cmbComPort.Text + "," + txtBaurdRate.Text);

            if (hPort == (IntPtr)(-1))
            {
                MessageBox.Show("error code:0x" + PACNET.ErrHandling.GetLastError().ToString("X") + "," + PACNET.ErrHandling.GetErrorMessage(PACNET.ErrHandling.GetLastError()));
            }
            else
            {
                btnOpenCOM.Enabled = false;
                btnCloseCOM.Enabled = true;
            }
        }

        private void btnCloseCOM_Click(object sender, EventArgs e)
        {
            //Close com port
            PACNET.UART.Close(hPort);
            btnOpenCOM.Enabled = true;
            btnCloseCOM.Enabled = false;
        }

        private void btnWriteAO_Click(object sender, EventArgs e)
        {
            bool iRet;

            //Write AO data
            iRet = PACNET.PAC_IO.WriteAO_MF(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), Convert.ToInt32(txtAOChannel.Text), Convert.ToInt32(txtAOTotalChannel.Text), Convert.ToSingle(txtAOValue.Text));
            if (iRet == false)
                MessageBox.Show("error code:0x" + PACNET.ErrHandling.GetLastError().ToString("X") + "," + PACNET.ErrHandling.GetErrorMessage(PACNET.ErrHandling.GetLastError()));
        }

        private void cmdModules_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch(cmdModules.Text)
            {
                case " tM-DA1PR1" :
                    btnWriteAO.Enabled = true;
                    btnWrite.Enabled = false;
                    txtAOChannel.Text = "1";
                    break;
            }
        }

        private void btnWrite_Click(object sender, EventArgs e)
        {
            bool iRet;

            //Write AO data
            iRet = PACNET.PAC_IO.WriteAO(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), Convert.ToInt32(txtAOChannel.Text), Convert.ToInt32(txtAOTotalChannel.Text), Convert.ToSingle(txtAOValue.Text));
            if (iRet == false)
                MessageBox.Show("error code:0x" + PACNET.ErrHandling.GetLastError().ToString("X") + "," + PACNET.ErrHandling.GetErrorMessage(PACNET.ErrHandling.GetLastError()));
        }


    }
}
